# <center><img src="https://raw.githubusercontent.com/eclufsc/ophidian/master/logo.png" width=80> Ophidian [![Build Status](https://travis-ci.org/eclufsc/ophidian.svg?branch=development)](https://travis-ci.org/eclufsc/ophidian)
<center><span style="color:green"><b>O<b></span>pen-Source Library for <span style="color:green"><b>Ph</span>ys<span style="color:green"><b>i</span>cal <span style="color:green"><b>D</span>es<span style="color:green"><b>i</span>gn Rese<span style="color:green"><b>a</span>rch and Teachi<span style="color:green"><b>n</span>g </center>

-----------

Ophidian is an open-source library developed at [Embedded Computing Lab (ECL)](http://eclab.paginas.ufsc.br/), [Federal University of Santa Catarina (UFSC)](http://ufsc.br/), [Brazil](https://www.google.com.br/maps/place/Departamento+de+Inform%C3%A1tica+e+Estat%C3%ADstica/@-27.600561,-48.520762,17z/data=!3m1!4b1!4m5!3m4!1s0x95273900f56d3f99:0xc2fd35f96d3fb9b3!8m2!3d-27.6005658!4d-48.5185733?hl=en). The main objective of Ophidian project is to provide a multi-platform library to facilitate the research and teaching of topics associated to the physical design of integrated circuits.

Ophidian was conceived by [Chrystian Guth](http://csguth.com), [Renan Netto](https://renannetto.github.io/), and [Vinicius Livramento](http://vinilivramento.com), under the advise of [Prof. José Güntzel](https://www.inf.ufsc.br/~j.guntzel/), during their research activities at Federal University of Santa Catarina.

Currently, Ophidian has many collaborators in the same university that support its development.
* Bernardo Mendonça
* [Chrystian Guth](http://csguth.com)
* [José Güntzel](https://www.inf.ufsc.br/~j.guntzel/)
* [Renan Netto](https://renannetto.github.io/)
* Thiago Barbato
* Tiago Fontana
* Sheiny Almeida
* [Vinicius Livramento](http://vinilivramento.com)


-----------

This repository adds the code used in the experiments of the paper accepted on ISPD 2019 
entitled "How deep learning can drive physical synthesis towards more predictable legalization".
The folders are organized as follows:
 - experiments/ispd2019/generate_csv_from_kd_tree_partitions.cpp: run the experiments to generate data for neural network training
 - experiments/ispd2019/run_kdtree: run the experiments to evaluate the legalization using kd tree partitioning
 - python/train_ann_histogram_for_classification.py: train the ann model using python
 - knime_models: folder with the files used to train the models using knime

To run any experiment, build ophidian and run "run_experiments <experiment_name>".
For example, to run the legalization using kd tree partitioning and the machine learning model
for the ICCAD2017 circuits, use "run_experiments "ICCAD2017 Kdtree legalization maximum displacement with prediction"".

In order to build the project, you need to have the tensorflow c++ libraries in your computer so that they can be linked through cmake.
You can find more information of how to do so in this repository: https://github.com/PatWie/tensorflow-cmake
